from reinvent_models.patformer.patformer_model import PatformerModel
from reinvent_models.model_factory.generative_model_base import GenerativeModelBase


class PatformerAdapter(GenerativeModelBase):

    def __init__(self, path_to_file: str, mode: str):
        self.generative_model = PatformerModel.load_from_file(path_to_file, mode)
        self.vocabulary = self.generative_model.vocabulary
        self.max_sequence_length = self.generative_model.max_sequence_length
        self.network = self.generative_model.network

    def save_to_file(self, path):
        self.generative_model.save_to_file(path)

    #TODO add types
    def likelihood(self, src, src_mask, trg, trg_mask):
        return self.generative_model.likelihood(src, src_mask, trg, trg_mask)

    def sample(self, src, src_mask, decode_type='multinomial'):
        return self.generative_model.sample(src, src_mask, decode_type)

    def set_mode(self, mode: str):
        self.generative_model.set_mode(mode)

    def get_network_parameters(self):
        return self.generative_model.get_network_parameters()

    def get_vocabulary(self):
        return self.vocabulary
